Subject: ASN.1 definitions in draft-ietf-ldapbis-syntaxes-01.txt

From: "Jim Sermersheim" <[email-masked]>
Date: Fri, 01 Mar 2002 12:15:00 -0700

For any multipart syntax, could we include the ASN.1 definition, rather
than including it in prose?
I'm thinking of examples like Section 3.9 and 3.13.

For example, in 3.9, rather than "A value in this syntax is a set of
the ASN.1 enumerated INTEGER 
   values", we could have:

DeliveryMethod ::= SET OF ENUMERATED {
	any	(0),
	mhs	(1),
	physical	(2),
	telex	(3),
	teletex	(4),
	g3fax	(5),
	g4fax	(6),
	ia5	(7),
	videotex	(8),
	telephone	(9) }

(If that's actually what the statement means.)

Also, there are many multipart syntaxes that lack an ASN.1 definition,
do we plan to define the ASN.1 for these?

Jim

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Fri, 01 Mar 2002 11:43:56 -0800

>I'm thinking of examples like Section 3.9 and 3.13.

I think we need to be very clear which ASN.1 data type definition
is associated with the OID.  For example

  This LDAP syntax associates the OID 1.3.6.1.4.1.1466.115.121.1.14
  with the ASN.1 data type DeliveryMethod [REFERENCE].  The 
  following "native" string representation is defined for this
  syntax.

An informative copy of the ASN.1 data definition could be
provided as well.

Then the string representation should be defined in terms
of the referenced ASN.1 data type.  

>do we plan to define the ASN.1 for these?

I believe each and every LDAP syntax as an associated ASN.1 definition.
In some cases, it might be implicit or defined in some obscure
document.  We need to clarify for each and every syntax what the
ASN.1 definition is.

There may be some syntaxes which are best removed then clarified.

Kurt

---

From: "Steven Legg" <[email-masked]>
Date: Tue, 5 Mar 2002 10:18:51 +1100

Jim,

> do we plan to define the ASN.1 for these?

In reviewing the LDAP syntaxes some time ago I found ASN.1 type
definitions for all but three syntaxes. These were:

	LDAP Syntax Description - 1.3.6.1.4.1.1466.115.121.1.54
	LDAP Schema Definition  - 1.3.6.1.4.1.1466.115.121.1.56
	LDAP Schema Description - 1.3.6.1.4.1.1466.115.121.1.57

I proposed this ASN.1 type for LDAP Syntax Description:

    LDAPSyntaxDescription ::= SEQUENCE {
        identifier       OBJECT IDENTIFIER,
        description      DirectoryString { ub-schema } OPTIONAL
    }

I proposed this ASN.1 type for LDAP Schema Definition:

    LDAPSchemaDefinition ::= SEQUENCE {
        identifier      OBJECT IDENTIFIER,
        name            SET OF DirectoryString { ub-schema } OPTIONAL,
        obsolete        BOOLEAN DEFAULT FALSE,
        information     LDAPSchemaInformation
    }

    LDAPSchemaInformation ::= SEQUENCE {
        imports         [0] SET SIZE (1..MAX) OF OBJECT IDENTIFIER OPTIONAL,
        classes         [1] SET SIZE (1..MAX) OF OBJECT-CLASS.&id OPTIONAL,
        attributes      [2] SET SIZE (1..MAX) OF ATTRIBUTE.&id OPTIONAL,
        matching-rules  [3] SET SIZE (1..MAX) OF MATCHING-RULE.&id OPTIONAL,
        syntaxes        [4] SET SIZE (1..MAX) OF OBJECT IDENTIFIER OPTIONAL
    }

If the group agrees, Kathy and I can put these definitions, plus all the
others I've found, into the syntaxes I-D.

Consensus on LDAP Schema Description was to remove it since it has no
defined native or binary encoding, and no-one implements it.

Regards,
Steven

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Mon, 04 Mar 2002 16:10:52 -0800

>        LDAP Schema Description - 1.3.6.1.4.1.1466.115.121.1.57

Only the first is defined for use in LDAP by RFC 2252 [in
section 6].  The others are defined elsewhere.  That is, the
table contains a list of syntaxes defined 'thus far', it is
not their specification.

Only the syntaxes defined in RFC 2252, Section 6 and RFC 2256,
Section 6 should be described in RFC 2252bis.  The specification
of these syntaxes should be clarified as to their ASN.1 data type
definition, but no new syntaxes can be added.

Kurt

---

From: "Steven Legg" <[email-masked]>
Date: Tue, 5 Mar 2002 11:45:22 +1100

Kurt,

Kurt D. Zeilenga wrote:
> Section 6 should be described in RFC 2252bis.

Okay. LDAP Syntax Description is the only applicable syntax for
which we don't have a corresponding ASN.1 type.

> The specification

Are you for or against adding an ASN.1 type definition for
LDAP Syntax Description to RFC2252bis ?

Regards,
Steven

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Mon, 04 Mar 2002 16:57:06 -0800

>LDAP Syntax Description to RFC2252bis ?

For.  Every LDAP syntax should have a ASN.1 type definition
(in many cases it will be a constrained OCTET STRING).

I have no objection to the one you offer for LDAP Syntax Description.

Kurt